//dsMeter_ready

debug("DEBUG","event;"+raisedEvent.name);
//debug("DEBUG","event;"+JSON.stringify(raisedEvent));

switch(raisedEvent.name){

case "model_ready":
    Property.load();
    initializePropertyTree();
    var timer=timers["TIMER_configWatchdog"];
    var parameter={};
    callTimer(timer.name,timer.id,timer.duration,parameter);

    //TODO: Create cluster, add devices to cluster, write clusterID to
    //the property tree.
    break;

case timers["TIMER_configWatchdog"].name:
    //call the timer that initializes the airboxes to the default level
    var timer=timers["TIMER_discoverAirboxes"];
    var parameter={};
    var Dict={};
    callTimer(timer.name,timer.id,timer.duration,parameter);

    discoverAirboxes(); // reset the errors at initialization time
    clearAllAirboxErrors();
    airbox_configureWatchdogFSM("initialize",0,Dict);

    try{
	cloudService.fetchNotificationList(createNotificationList);
    }
    catch(err){
	// report error,  no cloud activated
    }


    break;

case  timers["TIMER_discoverAirboxes"].name:
    var parameter={};
    timer=timers["TIMER_checkFilterReplacement"];
    callTimer(timer.name,timer.id,timer.duration,parameter);

    // set the timer to verify the filter replacement next time

    // set airboxes to default value
    var Dict={};
    airboxSendSceneFSM("initialize",0,Dict,parseInt(AIRBOX_DEFAULT_LEVEL)+2);
    saveToPropertyTree("Controller/CurrentLevel",parseInt(AIRBOX_DEFAULT_LEVEL),true);

    openExhaustFlap();

    saveToPropertyTree_nostore("Controller/propTreeReady",true,true); // mark the app as ready
    break;



case "wesco_UI":
    //debug("DEBUG","event;"+JSON.stringify(raisedEvent));
    parseUICommand(raisedEvent.parameter);
    break;


case "wesco_processedScene":
    var parameter = raisedEvent.parameter;

    var Scene=parameter["sceneID"];// parse the right scene
    var Dict={};
    debug("DEBUG","received scene:"+Scene);

    var currentLevel=-1;

    switch(parseInt(Scene)){
    case 0:
	currentLevel=0;
	break;
    case 5:
	currentLevel=1;
	break;
    case 17:
	currentLevel=2;
	break;
    case 18:
	currentLevel=3;
	break;
    case 19:
	currentLevel=4;
	break;
    default:
	currentLevel=-1;
	break;
    }

    if (currentLevel >= 0 && currentLevel <=4){
	saveToPropertyTree("Controller/CurrentLevel",currentLevel,true);
	airboxSendSceneFSM("initialize",0,Dict,currentLevel+2);
    }
    break;


case timers["TIMER_configureWatchdogFSM"].name:
    debug("DEBUG","event;configureWatchdogFSMTimer");
    var parameter = raisedEvent.parameter;
    var Device = parseInt(parameter['Device']);
    var Dict = JSON.parse(parameter['Dict']);
    var FSMState = parameter['FSMState'];

    airbox_configureWatchdogFSM(FSMState,Device,Dict);

    break;

case timers["TIMER_sendSceneFSM"].name:
    debug("DEBUG","event;sendSceneFSMTimer");
    var parameter = raisedEvent.parameter;
    var Device = parseInt(parameter['Device']);
    var Dict = JSON.parse(parameter['Dict']);
    var Scene= parseInt(parameter['Scene']);
    var FSMState = parameter['FSMState'];

    airboxSendSceneFSM(FSMState,Device,Dict,Scene);

    break;



case timers["TIMER_clearupAirboxError"].name:
    var parameter = raisedEvent.parameter;
    var dsuid = parameter['dsuid'];

    AirboxErrorFSM(dsuid,0,"Timer");

    break;


case timers["TIMER_sendPushNotification"].name:
    var parameter=raisedEvent.parameter;
    var Type=parameter['Type'];
    sendPushTargetsNotification(Type);
    break;


case timers["TIMER_checkFilterReplacement"].name:

    try{
	cloudService.fetchNotificationList(createNotificationList);
    }
    catch(err){
	// report error,  no cloud activated
    }

    if(checkAirboxFilterReplacement()){
	sendPushNotification("FilterReplacement");
	sendEmailFilterReplacement();
    }

    // set the timer to verify the filter replacement next time
    var timer=timers["TIMER_checkFilterReplacement"];
    var parameter={};
    callTimer(timer.name,timer.id,timer.duration,parameter);

    discoverAirboxes();

    //setAirboxesToLastCalledScene();

    break;

case "deviceStatusEvent":

    // Check if the event comes from an airbox

    var dsuid = raisedEvent.source['dsuid'];
    var AirboxPath="Airboxes/Devices/"+dsuid;

    // The error flag is set at the AirboxErrorFSM state machine when
    // an error is reported.  This flag can only be cleared up from
    // the UI.
    var errorCode=getFromPropertyTree(AirboxPath+"/errorCode","None",false);
    var errorFSMState=getFromPropertyTree(AirboxPath+"/errorFSMState","ready",true);

    if (errorCode===undefined || errorCode==ErrorCodes["no_error"]){
	if (isAirbox(dsuid)){
	    var statusIndex=raisedEvent.parameter.statusIndex;
	    var statusValue=raisedEvent.parameter.statusValue;
	    if (statusIndex==AIRBOX_ERROR_EVENT_STATUS_INDEX){
		if (statusValue >= AIRBOX_POWER_ERR){
		    // Call the airbox error routine
		    AirboxErrorFSM(dsuid,statusValue,"errorEvent");
		}
	    }
	}
    }
    break;

default:
    break;
} // end ... switch(raisedEvent.name){
